## roundcube 1.5.0+dfsg.1

=== Makefile ===
GITREMOTE=git://github.com/roundcube/roundcubemail.git
GITBRANCH=release-1.5
GPGKEY=devs@roundcube.net
VERSION=1.5.0
 
all: clean complete dependent framework
 
complete: roundcubemail-git
	cp -RH roundcubemail-git roundcubemail-$(VERSION)
	(cd roundcubemail-$(VERSION); jq '.require += {"kolab/net_ldap3": "~1.1.1"} | del(.suggest."kolab/net_ldap3")' --indent 4 composer.json-dist > composer.json)
	(cd roundcubemail-$(VERSION); php /tmp/composer.phar install --prefer-dist --no-dev --ignore-platform-reqs)
	(cd roundcubemail-$(VERSION); bin/install-jsdeps.sh --force)
	(cd roundcubemail-$(VERSION); bin/jsshrink.sh program/js/publickey.js; bin/jsshrink.sh plugins/managesieve/codemirror/lib/codemirror.js)
	(cd roundcubemail-$(VERSION); rm jsdeps.json bin/install-jsdeps.sh *.orig; rm -rf vendor/masterminds/html5/test vendor/pear/*/tests vendor/*/*/.git* vendor/pear/crypt_gpg/tools vendor/pear/console_commandline/docs vendor/pear/mail_mime/scripts vendor/pear/net_ldap2/doc vendor/pear/net_smtp/docs vendor/pear/net_smtp/examples vendor/pear/net_smtp/README.rst vendor/endroid/qrcode/tests temp/js_cache)
	tar czf roundcubemail-$(VERSION)-complete.tar.gz roundcubemail-$(VERSION)
	rm -rf roundcubemail-$(VERSION)

dependent: roundcubemail-git
	cp -RH roundcubemail-git roundcubemail-$(VERSION)
	tar czf roundcubemail-$(VERSION).tar.gz roundcubemail-$(VERSION)
	rm -rf roundcubemail-$(VERSION)
 
framework: roundcubemail-git /tmp/phpDocumentor.phar
	cp -r roundcubemail-git/program/lib/Roundcube roundcube-framework-$(VERSION)
	(cd roundcube-framework-$(VERSION); php /tmp/phpDocumentor.phar -d . -t ./doc --title="Roundcube Framework" --defaultpackagename="Framework" --template="clean")
	(cd roundcube-framework-$(VERSION); rm -rf doc/phpdoc-cache* .phpdoc)
	tar czf roundcube-framework-$(VERSION).tar.gz roundcube-framework-$(VERSION)
	rm -rf roundcube-framework-$(VERSION)

sign:
	gpg -u $(GPGKEY) -a --detach-sig roundcubemail-$(VERSION).tar.gz
	gpg -u $(GPGKEY) -a --detach-sig roundcubemail-$(VERSION)-complete.tar.gz
	gpg -u $(GPGKEY) -a --detach-sig roundcube-framework-$(VERSION).tar.gz

verify:
	gpg -v --verify roundcubemail-$(VERSION).tar.gz{.asc,}
	gpg -v --verify roundcubemail-$(VERSION)-complete.tar.gz{.asc,}
	gpg -v --verify roundcube-framework-$(VERSION).tar.gz{.asc,}

shasum:
	shasum -a 256 roundcubemail-$(VERSION).tar.gz roundcubemail-$(VERSION)-complete.tar.gz roundcube-framework-$(VERSION).tar.gz

roundcubemail-git: buildtools
	git clone $(GITREMOTE) roundcubemail-git
	(cd roundcubemail-git; git checkout $(GITBRANCH))
	(cd roundcubemail-git; bin/jsshrink.sh; bin/updatecss.sh; bin/cssshrink.sh)
	(cd roundcubemail-git/skins/elastic; \
		lessc --clean-css="--s1 --advanced" styles/styles.less > styles/styles.min.css; \
		lessc --clean-css="--s1 --advanced" styles/print.less > styles/print.min.css; \
		lessc --clean-css="--s1 --advanced" styles/embed.less > styles/embed.min.css)
	(cd roundcubemail-git/bin; rm -f transifexpull.sh package2composer.sh)
	(cd roundcubemail-git; find . -name '.gitignore' | xargs rm)
	(cd roundcubemail-git; find . -name '.travis.yml' | xargs rm)
	(cd roundcubemail-git; rm -rf tests plugins/*/tests .git* .tx* .ci* .editorconfig* index-test.php Dockerfile Makefile)
	(cd roundcubemail-git; sed -i '' 's/1.5-git/$(VERSION)/' index.php public_html/index.php installer/index.php program/include/iniset.php program/lib/Roundcube/bootstrap.php)
	(cd roundcubemail-git; sed -i '' 's/# Unreleased/# Release $(VERSION)'/ CHANGELOG.md)

buildtools: /tmp/composer.phar
	npm install -g uglify-js
	npm install -g lessc
	npm install -g less-plugin-clean-css
	npm install -g csso-cli
	which -s jq || echo "!!!!!! Please install jq (https://stedolan.github.io/jq/) !!!!!!"

/tmp/composer.phar:
	curl -sS https://getcomposer.org/installer | php -- --install-dir=/tmp/

/tmp/phpDocumentor.phar:
	curl -sSL https://phpdoc.org/phpDocumentor.phar -o /tmp/phpDocumentor.phar

clean:
	rm -rf roundcubemail-git
	rm -rf roundcubemail-$(VERSION)*

=== debian/changelog ===
roundcube (1.5.0+dfsg.1-2) unstable; urgency=medium

  * CI: Restore piuparts job.
  * DEP-8: config-ownership-perms: Add Restrictions: allow-stderr.

 -- Guilhem Moulin <guilhem@debian.org>  Sat, 23 Oct 2021 20:00:35 +0200

roundcube (1.5.0+dfsg.1-1) unstable; urgency=low

  * New upstream release.  Highlights for major version 1.5 include:
    - full PHP 8.0 support (closes: #977687)
    - dark mode for Elastic skin
    - collected recipients and trusted senders
    - moving recipients between inputs with drag & drop
    - full unicode support with MySQL database
    - support of IMAP LITERAL [RFC7888]
    - support of [RFC2231] encoded names
    - cache refactoring
  * Ship upstream's bin/updatedb.sh to roundcube-core.
  * d/t/dbconfig-no-thanks: Also run bin/updatedb.sh.
  * d/t/dbconfig-no-thanks: Check DB ownership and permissions.
  * Exclude spellchecker from build-time and DEP8 tests, as dictionary
    mismatch makes it too brittle.
  * d/pkg-php-tools-overrides: Remove useless roundcube/net_sieve builtin.

 -- Guilhem Moulin <guilhem@debian.org>  Sat, 23 Oct 2021 09:47:50 +0200

roundcube (1.5~rc+dfsg.1-3) experimental; urgency=medium

  * DEP-8: Add test for dbconfig-no-thanks (set custom $config['db_dsnw']).
  * Create symlink var/lib/roundcube/SQL pointing to usr/share/roundcube/SQL.
    This is required for dbconfig-no-thanks deployments (closes: #996613).
  * Refresh lintian overrides to accommodate lintian v2.109.
  * Retroactively update d/roundcube-core.NEWS to advertise the 1.4 smtp_*
    default settings (closes: #994446).

 -- Guilhem Moulin <guilhem@debian.org>  Sat, 16 Oct 2021 23:20:50 +0200

roundcube (1.5~rc+dfsg.1-2) experimental; urgency=medium

  * Replace `which` with `command -v` in maint scripts.
  * Refresh lintian overrides to accommodate lintian v2.107.
  * Bump Standards-Version to 4.6.0 (no changes needed).
  * Remove 4 obsolete maintscript entries in 2 files.
  * Set upstream metadata fields: Security-Contact.

 -- Guilhem Moulin <guilhem@debian.org>  Fri, 08 Oct 2021 20:53:01 +0200

roundcube (1.5~rc+dfsg.1-1) experimental; urgency=medium

  * New upstream release candidate 1.5 (closes: #949629).
  * d/rules: Exclude tinymce/js/tinymce/tinymce.d.ts in accordance with
    jsdeps.json.

 -- Guilhem Moulin <guilhem@debian.org>  Tue, 06 Jul 2021 12:00:42 +0200

roundcube (1.5~beta+dfsg.1-4) experimental; urgency=medium

  * d/roundcube-core.cron.daily, d/addsqlupdate.sh: `set -ue` and improve
    quoting.
  * d/*: Fix space damage.
  * bin/update.sh: Hardcode define('INSTALL_PATH', '/var/lib/roundcube/');
    (closes: #989140).
  * d/roundcube-core.postinst: Set DEBIAN_PKG=[0|1] for symmetry.
  * d/p/debianize-config.patch: Comment out sample plugins, see #884992.

 -- Guilhem Moulin <guilhem@debian.org>  Sat, 29 May 2021 15:03:39 +0200

roundcube (1.5~beta+dfsg.1-3) experimental; urgency=medium

  * d/*.post*, d/*.config: Improve style consistency.
  * d/*.post*: pathfind(): Keep IFS null (instead of setting it to the empty
    string) if it was null before.
  * d/roundcube-core.postinst: Set ln(1)'s '-T' to flag protect against
    undesired semantics should the target be an existing directory.
  * d/roundcube-core.postinst, d/roundcube-core.config: Replace useless calls
    to sed.
  * d/*.pre*, d/*.post*, d/*.config: Fix space damage.
  * d/roundcube-core.postinst: Make configuration sample parsing and reading
    roundcube/hosts more robust.
  * d/roundcube-core.postinst: 3DES key generation: Use a random 18-bytes long
    string base64 encoded (the key needs to be 24 bytes long).
  * d/roundcube-core.postinst: lighttpd: Prefer the more efficient
    fastcgi-php-fpm over fastcgi-php on lighttpd 1.4.55-2 and later.
  * d/copyright: Add self.
  * DEP-8: Add basic Apache2 and lighttpd tests.
  * DEP-8: Add configuration file and log/temp directory ownership and mode
    checks.
  * DEP-8: Add an hardened deployment, with a dedicated PHP-FPM pool and
    dedicated user/group (so the HTTPd can't read sensitive roundcube data).
  * d/roundcube-core.post*: Reload webserver with deb-systemd-invoke(1) when
    possible.
  * d/roundcube-core.postinst: Avoid running bin/update.sh with root
    privileges, depending on /etc/roundcube/config.inc.php's ownership and
    mode: if the file is word-readable then issue a warning and run as
    www-data; otherwise, if the file not root-owned then run as its owner;
    otherwise, if the file is group readable and is not group owned by root,
    and the group is used as a primary group for a single user, then use that
    user.  Should all that fail root privileges are preserved and a warning is
    issued.
  * d/roundcube-core.postinst: Issue a warning if a .dpkg-new leak is
    dedected.

 -- Guilhem Moulin <guilhem@debian.org>  Mon, 17 May 2021 21:00:08 +0200

roundcube (1.5~beta+dfsg.1-2) experimental; urgency=medium

  * Add hunspell-en-us to Build-Depends and DEP-8 tests dependencies as
    spellcheck tests rely on that dictionary.

 -- Guilhem Moulin <guilhem@debian.org>  Mon, 08 Mar 2021 19:14:45 +0100

roundcube (1.5~beta+dfsg.1-1) experimental; urgency=medium

  * New upstream beta release (closes: #977687).
  * Change default spellchecker engine from pspell to enchant as the latter
    is better supported and more flexible.
  * d/copyright: Update Files-Excluded stanza for tinymce component.
  * d/uupdate: Fix tinymce-langs URL.
  * d/control: Bump dependencies to match jsdeps.json and composer.json-dist.
  * d/control: Update build dependencies for the improved test suite.
  * Update d/copyright.
  * Fix DEP-8 tests: The test suite now requires reads the configuration file,
    so we need to run it as www-data.  We test with SQLite3 backend, and also
    the default backend (MySQL) on testbeds providing container-level
    isolation.
  * d/rules: Treat plugins/*/readme* (not only plugins/*/README*) as
    documentation.
  * CI: Disable piuparts which is bound to fail due to the schema upgrade.



=== debian/rules ===
#!/usr/bin/make -f

SRC_FILES := $(shell find program skins plugins -path program/js/tinymce -prune -o -type f -print)
PLUGINS := $(patsubst plugins/%/composer.json,%,$(wildcard plugins/*/composer.json))
SKINS := $(patsubst skins/%/meta.json,%,$(wildcard skins/*/meta.json))
CORE_PLUGINS = filesystem_attachments jqueryui

# don't use bin/install-jsdeps.sh on purpose: we need to export to the right place and minify manually
JSDEPS_FILES = program/js/publickey.js \
	$(shell find tinymce/js/tinymce -path tinymce/js/tinymce/themes/mobile -prune -o \
		\( \! -path tinymce/js/tinymce/license.txt \! -path tinymce/js/tinymce/langs/README.md \
			\! -path tinymce/js/tinymce/README.md \! -path tinymce/js/tinymce/tinymce.d.ts \
			-type f \) \
		-printf "program/js/tinymce/%P\\n" )
JSDEPS_FILES_NOSHRINK = $(patsubst tinymce-langs/%,program/js/tinymce/langs/%,$(wildcard tinymce-langs/*.js))

%:
	dh $@ --with phpcomposer

program/js/publickey.js: $(wildcard debian/missing-sources/publickey-*.js)
	install -m0644 -DT -- $< $@

program/js/tinymce/%: tinymce/js/tinymce/%
	install -m0644 -DT -- $< $@

program/js/tinymce/langs/%.js: tinymce-langs/%.js
	install -m0644 -DT -- $< $@

JS_MINFILES = $(patsubst %.js,%.min.js,$(filter-out %.min.js,$(filter %.js,$(SRC_FILES) $(JSDEPS_FILES))))
CSS_MINFILES = $(patsubst %.css,%.min.css,$(filter-out %.min.css, \
		$(filter %.css,$(SRC_FILES) $(JSDEPS_FILES))) $(CSS_GENFILES_ELASTIC))
CSS_GENFILES_ELASTIC = $(addprefix skins/elastic/styles/,styles.css print.css embed.css)
, = ,

# Minify JS: generate .min.js from .js source (cf. bin/jsshrink.sh)
%.min.js: %.js
	uglifyjs --compress --mangle $(if $(filter $@.map,$(GENERATED_MAPFILES)),--source-map "base='$(dir $@)'$(,)url='$(notdir $@).map'",) \
		-o $@ -- $<

# Minify CSS: generate .min.css from .css source (cf. bin/cssshrink.sh)
CSS_STAMPFILE = updatecss-stamp
%.min.css: %.css $(CSS_STAMPFILE)
	cd $(dir $@) && cleancss $(if $(filter $@.map,$(GENERATED_MAPFILES)),--source-map,) -o $(notdir $@) -- $(notdir $<)

# XXX bin/updatecss.sh edits CSS sources in place, so auto_clean might
# not cleanup; it is idempotent so it doesn't matter too much for us though
updatecss: $(CSS_STAMPFILE)
$(CSS_STAMPFILE): $(filter-out %.min.css,$(filter %.css,$(SRC_FILES))) $(CSS_GENFILES_ELASTIC)
	env ROUNDCUBE_CONFIG_DIR=$(CURDIR)/config bin/updatecss.sh
	touch -- $@
.PHONY: updatecss

# Cf. skins/elastic/README.md
$(CSS_GENFILES_ELASTIC): skins/elastic/%.css: skins/elastic/%.less
	cd skins/elastic && lessc --source-map "$*.less" "$*.css"

# For each plugin with a config.inc.php.dist, we create a config.inc.php with dummy content
PLUGINS_CONFIGURABLE = $(patsubst plugins/%/config.inc.php.dist,%, \
	$(wildcard $(patsubst %,plugins/%/config.inc.php.dist,$(PLUGINS))))
PLUGIN_CONF_GEN = $(patsubst %,plugins/%/config.inc.php,$(PLUGINS_CONFIGURABLE))
$(PLUGIN_CONF_GEN): plugins/%/config.inc.php: plugins/%/config.inc.php.dist
	$(file >$@,<?php)
	$(file >>$@,// Empty configuration for $*)
	$(file >>$@,// See /usr/share/roundcube/plugins/$*/config.inc.php.dist for instructions)
	$(file >>$@,// Check the access right of the file if you put sensitive information in it.)
	$(file >>$@,$$config=array();)
	$(file >>$@,?>)

GENERATED_FILES = $(PLUGIN_CONF_GEN) $(JSDEPS_FILES) $(JSDEPS_FILES_NOSHRINK) \
	$(JS_MINFILES) $(CSS_MINFILES) $(CSS_GENFILES_ELASTIC)

# Skip source map creation for the bundled stuff
GENERATED_MAPFILES = $(addsuffix .map,$(filter-out program/js/publickey.min.js program/js/tinymce/%, \
	$(filter %.css %.js,$(JS_MINFILES) $(CSS_MINFILES) $(CSS_GENFILES_ELASTIC))))
GENERATED_FILES += $(GENERATED_MAPFILES)
$(GENERATED_MAPFILES): %.map: | % ;

# Pre-compress minified files (and also tinymce-langs/*.js and embed.css,
# since for these the client never requests the minified version)
COMPRESSED_FILES = $(JS_MINFILES) $(CSS_MINFILES) \
	$(filter %.css %.js,$(JSDEPS_FILES_NOSHRINK) $(CSS_GENFILES_ELASTIC))
COMPRESSED_FILES := $(addsuffix .gz,$(COMPRESSED_FILES))
GENERATED_FILES += $(COMPRESSED_FILES)
$(COMPRESSED_FILES): %.gz: %
	pigz -11 -mnk -- $<

execute_after_dh_auto_clean:
	debconf-updatepo
	@rm -f -- $(GENERATED_FILES) $(CSS_STAMPFILE)
	@rm -rf -- program/js/tinymce

override_dh_auto_build: $(GENERATED_FILES) ;
.SECONDARY:

override_dh_auto_test:
	ln -sfT ../.github/config-test.inc.php config/config-test.inc.php
	env RCUBE_INSTALL_PATH=$(CURDIR) phpunit -c tests/phpunit.xml --exclude-group=qrcode

NONCORE_PLUGINS = $(filter-out $(CORE_PLUGINS),$(PLUGINS))
execute_after_dh_install:
	install -m0644 .htaccess debian/roundcube-core/etc/roundcube/htaccess
	install -m0644 composer.json-dist debian/roundcube-core/usr/share/roundcube/composer.json

	# database intial
	install -m0644 -DT SQL/mysql.initial.sql    debian/roundcube-core/usr/share/dbconfig-common/data/roundcube/install/mysql
	install -m0644 -DT SQL/postgres.initial.sql debian/roundcube-core/usr/share/dbconfig-common/data/roundcube/install/pgsql
	install -m0644 -DT SQL/sqlite.initial.sql   debian/roundcube-core/usr/share/dbconfig-common/data/roundcube/install/sqlite3

	# database update
	cp -rt debian/roundcube-core/usr/share/dbconfig-common/data/roundcube/upgrade debian/sql/*

	# install plugins
ifneq ($(CORE_PLUGINS),)
	dh_install -proundcube-core $(addprefix plugins/,$(CORE_PLUGINS)) \
		usr/share/roundcube/plugins
endif
ifneq ($(NONCORE_PLUGINS),)
	dh_install -proundcube-plugins $(addprefix plugins/,$(NONCORE_PLUGINS)) \
		usr/share/roundcube/plugins
endif

	# install plugin configuration
	$(foreach plugin,$(PLUGINS_CONFIGURABLE), \
		dh_install -p$(if $(filter $(plugin),$(CORE_PLUGINS)),roundcube-core,roundcube-plugins) \
			plugins/$(plugin)/config.inc.php etc/roundcube/plugins/$(plugin) && \
		) true

	# setup /usr/share/bug/$PACKAGE/control files
	$(foreach pkg,$(shell dh_listpackages), \
		install -m0644 -DT -- debian/bug.control debian/$(pkg)/usr/share/bug/$(pkg)/control && \
		) true

	# remove irrelevant upstream stuff from binary packages
	find debian/roundcube-*/usr/share/roundcube -name .gitignore -type f -delete
	rm -rf debian/roundcube-*/usr/share/roundcube/plugins/*/tests/
	rm -f debian/roundcube-core/etc/roundcube/config-test.inc.php

override_dh_installdocs:
	dh_installdocs --link-doc=roundcube-core -proundcube -proundcube-core
	dh_installdocs -proundcube-mysql -proundcube-pgsql -proundcube-sqlite3 -proundcube-plugins

	# remove documentation from /usr/share/roundcube/ and install into /usr/share/doc/roundcube-*/
	rm -f debian/roundcube-*/usr/share/roundcube/program/lib/Roundcube/README.md \
		debian/roundcube-*/usr/share/roundcube/skins/*/README* \
		debian/roundcube-*/usr/share/roundcube/plugins/*/README* \
		debian/roundcube-*/usr/share/roundcube/plugins/*/readme*

	$(foreach doc,$(wildcard skins/*/README* $(patsubst %,plugins/%/README*,$(CORE_PLUGINS))), \
		install -m0644 -DT $(doc) debian/roundcube-core/usr/share/doc/roundcube-core/$(doc) && \
		) true
	$(foreach doc,$(wildcard $(addprefix plugins/,\
			$(addsuffix /README*,$(NONCORE_PLUGINS)) $(addsuffix /readme*,$(NONCORE_PLUGINS)))), \
		install -m0644 -DT $(doc) debian/roundcube-plugins/usr/share/doc/roundcube-plugins/$(doc) && \
		) true

	install -m0755 -Dd debian/$(if $(filter managesieve,$(CORE_PLUGINS)),roundcube-core,roundcube-plugins)/usr/share/doc/roundcube-plugins/plugins/managesieve
	mv -nt debian/$(if $(filter managesieve,$(CORE_PLUGINS)),roundcube-core,roundcube-plugins)/usr/share/doc/roundcube-plugins/plugins/managesieve \
		debian/$(if $(filter managesieve,$(CORE_PLUGINS)),roundcube-core,roundcube-plugins)/usr/share/roundcube/plugins/managesieve/helpdocs

override_dh_phpcomposer:
	dh_phpcomposer --sourcedirectory=$(CURDIR)/debian/roundcube-core/usr/share/roundcube

execute_after_dh_link:
	# symlink plugin configuration (and delete existing usr/share/roundcube/plugins/*/config.inc.php
	# file which we installed as etc/roundcube/plugins/*/config.inc.php instead)
	$(foreach plugin,$(PLUGINS_CONFIGURABLE), \

=== debian/tests/control ===
# Running as www-data to read /etc/roundcube/config.inc.php and /etc/roundcube/debian-db.php
# XXX we exclude qrcode group as endroid/qrcode is not available in Debian
Test-Command: /sbin/runuser -u www-data -- env RCUBE_INSTALL_PATH=/var/lib/roundcube
 phpunit -c tests/phpunit.xml --exclude-group=qrcode
# WARN: roundcube-sqlite3 needs to appear *before* roundcube-core as otherwise it attempts to configure -mysql
Depends: php-crypt-gpg,
         php-gd,
         php-net-ldap3,
         phpunit,
         roundcube-sqlite3,
         roundcube-core,
         roundcube-plugins
# XXX for better coverage (Browser tests) we would need Laravel Dusk, see .github/run.sh and tests/Browser/README.md
Restrictions: superficial, needs-root

# out of the box deployment with default HTTPd
Tests: apache2
Depends: apache2, default-mysql-server, roundcube, curl
Restrictions: needs-root, isolation-container

# out of the box deployment with default lighttpd, both with php-fpm and
# php-cgi (prexisting fastcgi .php handler)
Tests: lighttpd
Depends: lighttpd (>= 1.4.55-2),
         default-mysql-server,
         php-cgi,
         php-fpm,
         php,
         roundcube,
         curl
Restrictions: needs-root, isolation-container

# check that ownership and permissions on configuration files and
# log/temp directories are sane; check also privilege drop for
# bin/update.sh
Tests: config-ownership-perms
Depends: roundcube-sqlite3, roundcube-core
Restrictions: allow-stderr, needs-root

# an hardened configuration with a dedicated PHP-FPM pool and dedicated
# user/group (so the HTTPd can't read sensitive roundcube data)
Tests: hardening-dedicated-user
Depends: nginx-light,
         default-mysql-server,
         php-fpm,
         php,
         roundcube,
         curl
Restrictions: needs-root, isolation-container

# dbconfig-no-thanks: set custom $config['db_dsnw']
Tests: dbconfig-no-thanks
Depends: apache2, dbconfig-no-thanks, roundcube-sqlite3, roundcube-core, curl
Restrictions: needs-root, isolation-container

## roundcube 1.6.0+dfsg

=== Makefile ===
#
# This file is used by developers to build release packages
#

GITREMOTE=https://github.com/roundcube/roundcubemail.git
GITBRANCH=master
GPGKEY=devs@roundcube.net
VERSION=1.6-git
SEDI=sed -i
WHICH=which

UNAME_S := $(shell uname -s)
ifeq ($(UNAME_S),Darwin)
    SEDI=sed -i ''
    WHICH=which -s
endif

all: clean complete dependent framework

complete: roundcubemail-git
	cp -RH roundcubemail-git roundcubemail-$(VERSION)
	(cd roundcubemail-$(VERSION); jq '.require += {"kolab/net_ldap3": "~1.1.1"} | del(.suggest."kolab/net_ldap3")' --indent 4 composer.json-dist > composer.json)
	(cd roundcubemail-$(VERSION); php /tmp/composer.phar install --prefer-dist --no-dev --ignore-platform-reqs --no-interaction)
	(cd roundcubemail-$(VERSION); bin/install-jsdeps.sh --force)
	(cd roundcubemail-$(VERSION); bin/jsshrink.sh program/js/publickey.js; bin/jsshrink.sh plugins/managesieve/codemirror/lib/codemirror.js)
	(cd roundcubemail-$(VERSION); rm -f jsdeps.json bin/install-jsdeps.sh *.orig; rm -rf temp/js_cache)
	(cd roundcubemail-$(VERSION); rm -rf vendor/pear/*/tests vendor/*/*/.git* vendor/*/*/.travis* vendor/*/*/phpunit.xml.dist vendor/pear/console_commandline/docs vendor/pear/net_ldap2/doc vendor/bacon/bacon-qr-code/test vendor/dasprid/enum/test)
	tar czf roundcubemail-$(VERSION)-complete.tar.gz roundcubemail-$(VERSION)
	rm -rf roundcubemail-$(VERSION)

dependent: roundcubemail-git
	cp -RH roundcubemail-git roundcubemail-$(VERSION)
	tar czf roundcubemail-$(VERSION).tar.gz roundcubemail-$(VERSION)
	rm -rf roundcubemail-$(VERSION)
 
framework: roundcubemail-git /tmp/phpDocumentor.phar
	cp -r roundcubemail-git/program/lib/Roundcube roundcube-framework-$(VERSION)
	(cd roundcube-framework-$(VERSION); php /tmp/phpDocumentor.phar -d . -t ./doc --title="Roundcube Framework" --defaultpackagename="Framework" --template="clean")
	(cd roundcube-framework-$(VERSION); rm -rf doc/phpdoc-cache* .phpdoc)
	tar czf roundcube-framework-$(VERSION).tar.gz roundcube-framework-$(VERSION)
	rm -rf roundcube-framework-$(VERSION)

sign:
	gpg -u $(GPGKEY) -a --detach-sig roundcubemail-$(VERSION).tar.gz
	gpg -u $(GPGKEY) -a --detach-sig roundcubemail-$(VERSION)-complete.tar.gz
	gpg -u $(GPGKEY) -a --detach-sig roundcube-framework-$(VERSION).tar.gz

verify:
	gpg -v --verify roundcubemail-$(VERSION).tar.gz.asc roundcubemail-$(VERSION).tar.gz
	gpg -v --verify roundcubemail-$(VERSION)-complete.tar.gz.asc roundcubemail-$(VERSION)-complete.tar.gz
	gpg -v --verify roundcube-framework-$(VERSION).tar.gz.asc roundcube-framework-$(VERSION).tar.gz

shasum:
	shasum -a 256 roundcubemail-$(VERSION).tar.gz roundcubemail-$(VERSION)-complete.tar.gz roundcube-framework-$(VERSION).tar.gz

roundcubemail-git: buildtools
	git clone --branch=$(GITBRANCH) --depth=1 $(GITREMOTE) roundcubemail-git
	(cd roundcubemail-git; bin/jsshrink.sh; bin/updatecss.sh; bin/cssshrink.sh)
	(cd roundcubemail-git/skins/elastic; \
		lessc --clean-css="--s1 --advanced" styles/styles.less > styles/styles.min.css; \
		lessc --clean-css="--s1 --advanced" styles/print.less > styles/print.min.css; \
		lessc --clean-css="--s1 --advanced" styles/embed.less > styles/embed.min.css)
	(cd roundcubemail-git/bin; rm -f transifexpull.sh package2composer.sh)
	(cd roundcubemail-git; find . -name '.gitignore' | xargs rm -f)
	(cd roundcubemail-git; find . -name '.travis.yml' | xargs rm -f)
	(cd roundcubemail-git; rm -rf tests plugins/*/tests .git* .tx* .ci* .editorconfig* index-test.php Dockerfile Makefile)
	(cd roundcubemail-git; $(SEDI) 's/1.6-git/$(VERSION)/' index.php public_html/index.php program/include/iniset.php program/lib/Roundcube/bootstrap.php)
	(cd roundcubemail-git; $(SEDI) 's/# Unreleased/# Release $(VERSION)'/ CHANGELOG.md)

buildtools: /tmp/composer.phar
	npm install uglify-js
	npm install lessc
	npm install less-plugin-clean-css
	npm install csso-cli
	@$(WHICH) jq || echo "!!!!!! Please install jq (https://stedolan.github.io/jq/) !!!!!!"

/tmp/composer.phar:
	curl -sS https://getcomposer.org/installer | php -- --install-dir=/tmp/

/tmp/phpDocumentor.phar:
	curl -sSL https://phpdoc.org/phpDocumentor.phar -o /tmp/phpDocumentor.phar

clean:
	rm -rf roundcubemail-git
	rm -rf roundcubemail-$(VERSION)*

=== debian/changelog ===
roundcube (1.6.0+dfsg-1) unstable; urgency=low

  * New upstream release.
  * d/p/fix-install-path.patch: Also adjust installer/index.php.
  * d/t/control: Factor stanzas with same dependencies and restrictions.
  * /etc/roundcube/*.php: Don't include files only once.
  * DEP-8: Run upstream installer checks in a dedicated autopkgtest.
  * d/t/cleanup: Sort sessions by changed date on error.
  * d/t/installer-checks: And also run 3rd step of installation checks.
  * DEP-8: Add ‘Restrictions: breaks-testbed’ when suitable.
  * DEP-8: Name inline tests.
  * debian/control: Replace 'Depends: libapache2-mod-php | php' with 'Depends:
    php'.
  * Add d/README.source to document the package workflow.

 -- Guilhem Moulin <guilhem@debian.org>  Fri, 29 Jul 2022 11:47:02 +0200

roundcube (1.6~rc+dfsg-2) experimental; urgency=medium

  * Adjust d/origtargz-diff.sh for 1.6~rc+dfsg.
  * Refresh lintian overrides to accommodate lintian v2.115.
  * Bump Standards-Version to 4.6.1 (no changes needed).
  * Promote GuzzleHttp\Client back to "require" from "suggest".
  * Revert "Don't install the installer into /usr/share/roundcube."
  * Run upstream installer checks for apache2 and lighttpd DEP-8 tests.
  * Add roundcube-cleandb.{service,timer} which replaces the cronjob on
    systems where PID1 is systemd.
  * Add roundcube-gc.{service,timer} to purge expired sessions, caches and
    tempfiles in the background in a scheduled fashion.
  * Don't force set session.gc_probability=1 since we don't have to rely on
    probabilistic synchronous garbage collection anymore.
  * Remove obsolete /etc/default/roundcube and /etc/cron.daily/roundcube-core
    files since removing temporary files is part of the normal garbage
    collection routine.
  * DEP-8: Create tempfiles in $AUTOPKGTEST_TMP not /tmp.
  * DEP-8: Test roundcube-{cleandb,gc}.service (cleanup and garbage collection
    routines).

 -- Guilhem Moulin <guilhem@debian.org>  Wed, 29 Jun 2022 20:23:02 +0200

roundcube (1.6~rc+dfsg-1) experimental; urgency=medium

  * New upstream release candidate 1.6.
  * d/u/signing-key.asc: Add Alec's key BEE674A019359DC1.
  * Refresh d/patches.

 -- Guilhem Moulin <guilhem@debian.org>  Sun, 12 Jun 2022 16:46:12 +0200

roundcube (1.6~beta+dfsg-2) experimental; urgency=medium

  * d/roundcube-core.NEWS: Mention roundcube-skin-* packages by name
    now that they cleared the NEW queue.
  * d/control: roundcube-core: Add 'Recommends: roundcube-skin-classic,
    roundcube-skin-larry'.
  * Update d/copyright.
  * d/watch: Add uversionmangle for /-(alpha|beta|rc)\d*$/.
  * d/watch: Improve dversionmangle.
  * d/sql/*.sql: Escape identifiers to fix compatibility with MySQL 8
    (LP: #1970428).
  * New script d/sqlupdate replacing d/addsqlupdate.sh.
  * Update d/sql for 1.6~beta+dfsg-1 (remove 2020122900 which is in
    d/sql/*/1.5.0+dfsg.1-1 already).
  * Run wrap-and-sort(1).
  * Remove d/t/fix-format_date-x.patch and generate an en_US.utf8 locale for
    the upstream test suite instead.  This adds Build-Depends: locales.

 -- Guilhem Moulin <guilhem@debian.org>  Wed, 11 May 2022 20:22:23 +0200

roundcube (1.6~beta+dfsg-1) experimental; urgency=medium

  * New beta upstream release.  Highlights for major version 1.6 include:
    - Full PHP 8.1 support (closes: #1000642)
    - Unified and simplified services connection options:
      . renamed `default_host` resp. `smtp_server` to `imap_host` resp.
        `smtp_host`
      . removed `default_port`, `smtp_port`, `managesieve_port` and
        `managesieve_usetls` options
    - The classic and larry skins are no longer included in the upstream
      repository hence are excluded from this source package; we will ship in
      separate packages.
  * Add d/roundcube-core.NEWS to highlight the above.
  * Update default value for roundcube/hosts template to "localhost:143" to
    match the upstream default.
  * Update d/copyright.
  * Update d/sql.
  * Refresh d/patches.  Remove the following patches (now obsolete or applied
    upstream):
    - fix-FTBFS-with-phpunit-8.patch
    - fix-file-list-in-phpunit-configuration.patch
    - fix-FTBFS-with-phpunit-9.patch
  * Add patch to fix `$rcmail->format_date(.., 'x')` calls.
  * Remove mismatched Lintian override.
  * Add 'Restrictions: rw-build-tree' to the phpunit DEP-8 test as it writes
    into tests/.phpunit.result.cache.
  * Add aspell-en and php-pspell to Build-Depends (unless under 'nocheck'
    build profile) and DEP-8 test to test Framework_SpellcheckerPspell.
  * Add hunspell-en-us and php-enchant to Build-Depends (unless under
    'nocheck' build profile) and DEP-8 test to test
    Framework_SpellcheckerEnchant.
  * Add php-roundcube-rtf-html-php to Build-Depends (unless under 'nocheck'
    build profile) and DEP-8 test to test Framework_TnefDecoder.
  * Add php-bacon-qr-code to Build-Depends (unless under 'nocheck'
    build profile) and DEP-8 test to test Actions_Contacts_Qrcode.
  * d/rules, d/t/control: Mark flaky tests as such and run phpunit with
    `--exclude-group=flaky --fail-on-skipped` in build-time and DEP-8 tests.
  * CI: Disable piuparts which is bound to fail due to the schema upgrade.
  * d/rules: Replace '$(dir $@)' with '$(@D)'.

 -- Guilhem Moulin <guilhem@debian.org>  Mon, 14 Mar 2022 00:16:05 +0100

roundcube (1.5.2+dfsg-1) unstable; urgency=medium

  * New upstream bugfix & security release (closes: #1003027).

 -- Guilhem Moulin <guilhem@debian.org>  Sun, 02 Jan 2022 22:50:42 +0100

roundcube (1.5.1+dfsg-1) unstable; urgency=medium

  * New upstream bugfix release.
  * Change repacking suffix to +dfsg from +dfsg.1.

 -- Guilhem Moulin <guilhem@debian.org>  Sat, 04 Dec 2021 15:07:42 +0100

=== debian/control ===
Source: roundcube
Section: web
Priority: optional
Maintainer: Debian Roundcube Maintainers <pkg-roundcube-maintainers@alioth-lists.debian.net>
Uploaders: Vincent Bernat <bernat@debian.org>,
           Sandro Knauß <hefee@debian.org>,
           Guilhem Moulin <guilhem@debian.org>
Build-Depends: aspell-en <!nocheck>,
               cleancss,
               debhelper-compat (= 13),
               dh-buildinfo,
               hunspell-en-us <!nocheck>,
               locales <!nocheck>,
               node-less (>= 3.0.0~),
               php-bacon-qr-code [!armel !armhf !i386 !mipsel] <!nocheck>,
               php-crypt-gpg <!nocheck>,
               php-enchant <!nocheck>,
               php-gd <!nocheck>,
               php-intl <!nocheck>,
               php-mail-mime <!nocheck>,
               php-masterminds-html5 <!nocheck>,
               php-mbstring,
               php-net-ldap3 <!nocheck>,
               php-pspell <!nocheck>,
               php-roundcube-rtf-html-php <!nocheck>,
               php-sqlite3 <!nocheck>,
               phpunit (>= 9~) <!nocheck>,
               pigz,
               pkg-php-tools,
               po-debconf,
               sqlite3 <!nocheck>,
               uglifyjs (>= 3)
Rules-Requires-Root: no
Homepage: https://www.roundcube.net/
Standards-Version: 4.6.1
Vcs-Git: https://salsa.debian.org/roundcube-team/roundcube.git -b debian/latest
Vcs-Browser: https://salsa.debian.org/roundcube-team/roundcube

Package: roundcube-core
Architecture: all
Pre-Depends: dpkg (>= 1.17.14)
Depends: dbconfig-common,
         debconf,
         libjs-bootstrap4 (>= 4.5.2~),
         libjs-codemirror (>= 5.58.3~),
         libjs-jquery (>= 3.5.1~),
         libjs-jquery-minicolors (>= 2.2.6~),
         libjs-jquery-ui (>= 1.12.0~),
         libjs-jstimezonedetect (>= 1.0.6~),
         libmagic1,
         php,
         php-cli,
         php-intl,
         php-json,
         php-mbstring,
         php-pear (>= 1:1.10.1),
         roundcube-mysql (= ${source:Version}) | roundcube-sqlite3 (= ${source:Version}) | roundcube-pgsql (= ${source:Version}),
         ucf,
         ${misc:Depends},
         ${phpcomposer:Debian-require}
Recommends: apache2 | lighttpd | spawn-fcgi | php-fpm | httpd-cgi,
            php-enchant,
            php-gd,
            roundcube-skin-classic,
            roundcube-skin-larry,
            ${phpcomposer:Debian-recommend}
Suggests: roundcube-plugins, ${phpcomposer:Debian-suggest}
Breaks: roundcube-plugins-extra (<= 0.6-20111030)
Replaces: roundcube-plugins-extra (<= 0.6-20111030),
          ${phpcomposer:Debian-replace}
Description: skinnable AJAX based webmail solution for IMAP servers
 RoundCube Webmail is a browser-based multilingual IMAP client with an
 application-like user interface. It provides full functionality
 expected from an e-mail client, including MIME support, address book,
 folder manipulation and message filters.
 .
 The user interface is fully skinnable using XHTML and CSS 2.
 .
 This package provides the core code for roundcube. You should install
 it along with one of the roundcube database metapackages.

Package: roundcube
Architecture: all
Pre-Depends: dpkg (>= 1.17.14)
Depends: roundcube-core (= ${source:Version}), ${misc:Depends}
Breaks: roundcube-core (<< 1.1.1+dfsg.1-1)
Description: skinnable AJAX based webmail solution for IMAP servers - metapackage
 RoundCube Webmail is a browser-based multilingual IMAP client with an
 application-like user interface. It provides full functionality
 expected from an e-mail client, including MIME support, address book,
 folder manipulation and message filters.
 .
 The user interface is fully skinnable using XHTML and CSS 2.
 .
 This package will install a full roundcube application.

Package: roundcube-mysql
Architecture: all
Depends: mariadb-client | default-mysql-client | virtual-mysql-client,
         php-mysql | php-mysqlnd,
         ${misc:Depends}
Suggests: mariadb-server | default-mysql-server
Description: metapackage providing MySQL dependencies for RoundCube
 This package provides MySQL dependencies for RoundCube Webmail, a
 skinnable AJAX based webmail solution for IMAP servers. Install this
 one if you want to use a MySQL database with RoundCube.

Package: roundcube-pgsql
Architecture: all
Depends: php-pgsql, postgresql-client, ${misc:Depends}
Suggests: postgresql
Description: metapackage providing PostgreSQL dependencies for RoundCube
 This package provides PostgreSQL dependencies for RoundCube Webmail,
 a skinnable AJAX based webmail solution for IMAP servers. Install
 this one if you want to use a PostgreSQL database with RoundCube.

Package: roundcube-sqlite3
Architecture: all
Depends: php-sqlite3, sqlite3, ${misc:Depends}
Description: metapackage providing SQLite dependencies for RoundCube
 This package provides SQLite dependencies for RoundCube Webmail,
 a skinnable AJAX based webmail solution for IMAP servers. Install
 this one if you want to use a SQLite database with RoundCube.

Package: roundcube-plugins
Architecture: all
Pre-Depends: dpkg (>= 1.17.14)
Depends: roundcube-core (= ${source:Version}), ${misc:Depends}
Suggests: php-cli, php-crypt-gpg, php-net-sieve, php-zip, python3
Breaks: roundcube-plugins-extra (<= 0.7-20120110)
Replaces: roundcube-plugins-extra (<= 0.7-20120110)
Description: skinnable AJAX based webmail solution for IMAP servers - plugins
 RoundCube Webmail is a browser-based multilingual IMAP client with an
 application-like user interface. It provides full functionality
 expected from an e-mail client, including MIME support, address book,
 folder manipulation and message filters.
 .
 The user interface is fully skinnable using XHTML and CSS 2.
 .
 This package provides several plugins for Roundcube. They should be
 enabled in the configuration of Roundcube.

## roundcube 1.6.1+dfsg

=== Makefile ===
--- 
+++ 
@@ -25,6 +25,7 @@
 	(cd roundcubemail-$(VERSION); bin/jsshrink.sh program/js/publickey.js; bin/jsshrink.sh plugins/managesieve/codemirror/lib/codemirror.js)
 	(cd roundcubemail-$(VERSION); rm -f jsdeps.json bin/install-jsdeps.sh *.orig; rm -rf temp/js_cache)
 	(cd roundcubemail-$(VERSION); rm -rf vendor/pear/*/tests vendor/*/*/.git* vendor/*/*/.travis* vendor/*/*/phpunit.xml.dist vendor/pear/console_commandline/docs vendor/pear/net_ldap2/doc vendor/bacon/bacon-qr-code/test vendor/dasprid/enum/test)
+	(cd roundcubemail-$(VERSION); echo "// generated by Roundcube install $(VERSION)" >> vendor/autoload.php)
 	tar czf roundcubemail-$(VERSION)-complete.tar.gz roundcubemail-$(VERSION)
 	rm -rf roundcubemail-$(VERSION)

=== debian/changelog ===
roundcube (1.6.1+dfsg-1ubuntu1) lunar; urgency=medium

  * Test suite: Adjust short date test to make it work with all ICUs.
    (Closes: #1030161)

 -- Amin Bandali <amin.bandali@canonical.com>  Wed, 01 Feb 2023 10:03:55 -0500

roundcube (1.6.1+dfsg-1) unstable; urgency=medium

  * New upstream bugfix release.
  * Update d/sql for 1.6.1+dfsg-1.
  * Fix d/README.source order.
  * Refresh d/patches.
  * d/roundcube-core.postinst: Add $config['imap_host'] to $CONFFILE.ucftmp if
    needs be.  This fixes d/t/config-ownership-perms.
  * d/t/config-ownership-perms: Use HOST:PORT in roundcube/hosts string.

 -- Guilhem Moulin <guilhem@debian.org>  Tue, 24 Jan 2023 01:42:19 +0100

roundcube (1.6.0+dfsg-2) unstable; urgency=medium

  * Salsa CI: Restore piuparts job.
  * Salsa CI: Install suitable RDBMS before running piuparts.
  * Salsa CI: Include recipes/debian.yml.
  * d/control: Build-Depends: Drop versioned constraint on uglifyjs.
  * Update standards version to 4.6.2, no changes needed.
  * Fix FTBFS (closes: #1026528).
  * d/s/lintian-overrides: Remove mismatched overrides.

 -- Guilhem Moulin <guilhem@debian.org>  Tue, 20 Dec 2022 20:36:47 +0100

roundcube (1.6.0+dfsg-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * No source change upload to rebuild with debhelper 13.10.

 -- Michael Biebl <biebl@debian.org>  Sat, 15 Oct 2022 12:43:57 +0200

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: roundcube
 Section: web
 Priority: optional
-Maintainer: Debian Roundcube Maintainers <pkg-roundcube-maintainers@alioth-lists.debian.net>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Roundcube Maintainers <pkg-roundcube-maintainers@alioth-lists.debian.net>
 Uploaders: Vincent Bernat <bernat@debian.org>,
            Sandro Knauß <hefee@debian.org>,
            Guilhem Moulin <guilhem@debian.org>
@@ -29,10 +30,10 @@
                pkg-php-tools,
                po-debconf,
                sqlite3 <!nocheck>,
-               uglifyjs (>= 3)
+               uglifyjs
 Rules-Requires-Root: no
 Homepage: https://www.roundcube.net/
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Vcs-Git: https://salsa.debian.org/roundcube-team/roundcube.git -b debian/latest
 Vcs-Browser: https://salsa.debian.org/roundcube-team/roundcube

=== debian/tests/control ===
# Running as www-data to read /etc/roundcube/config.inc.php and /etc/roundcube/debian-db.php
Features: test-name=upstream-testsuite
Test-Command: mkdir -p tests/.locale &&
 localedef -c -i en_US -f UTF-8 tests/.locale/en_US.utf8 &&
 /sbin/runuser -u www-data -- env RCUBE_INSTALL_PATH=/var/lib/roundcube LOCPATH="$(pwd)/tests/.locale"
  phpunit -c tests/phpunit.xml --exclude-group=flaky
# WARN: roundcube-sqlite3 needs to appear *before* roundcube-core as otherwise it attempts to configure -mysql
Depends: aspell-en,
         hunspell-en-us,
         locales,
         php-bacon-qr-code [!armel !armhf !i386 !mipsel],
         php-crypt-gpg,
         php-enchant,
         php-gd,
         php-net-ldap3,
         php-pspell,
         php-roundcube-rtf-html-php,
         phpunit,
         roundcube-sqlite3,
         roundcube-core,
         roundcube-plugins
# XXX for better coverage (Browser tests) we would need Laravel Dusk, see .github/run.sh and tests/Browser/README.md
Restrictions: superficial, needs-root, rw-build-tree

# out of the box deployment with default HTTPd
Tests: apache2, cleanup, installer-checks
Depends: apache2, default-mysql-server, roundcube, curl
Restrictions: breaks-testbed, isolation-container, needs-root

# out of the box deployment with default lighttpd, both with php-fpm and
# php-cgi (prexisting fastcgi .php handler)
Tests: lighttpd
Depends: lighttpd (>= 1.4.55-2),
         default-mysql-server,
         php-cgi,
         php-fpm,
         roundcube,
         curl
Restrictions: breaks-testbed, isolation-container, needs-root

# check that ownership and permissions on configuration files and
# log/temp directories are sane; check also privilege drop for
# bin/update.sh
Tests: config-ownership-perms
Depends: roundcube-sqlite3, roundcube-core
Restrictions: allow-stderr, breaks-testbed, needs-root

# an hardened configuration with a dedicated PHP-FPM pool and dedicated
# user/group (so the HTTPd can't read sensitive roundcube data)
Tests: hardening-dedicated-user
Depends: nginx-light,
         default-mysql-server,
         php-fpm,
         roundcube,
         curl
Restrictions: needs-root, isolation-container

# dbconfig-no-thanks: set custom $config['db_dsnw']
Tests: dbconfig-no-thanks
Depends: apache2, dbconfig-no-thanks, roundcube-sqlite3, roundcube-core, curl
Restrictions: breaks-testbed, isolation-container, needs-root

## roundcube 1.6.2+dfsg

=== Makefile ===
--- 
+++ 
@@ -3,11 +3,12 @@
 #
 
 GITREMOTE=https://github.com/roundcube/roundcubemail.git
-GITBRANCH=master
+GITBRANCH=release-1.6
 GPGKEY=devs@roundcube.net
 VERSION=1.6-git
 SEDI=sed -i
 WHICH=which
+PHP_VERSION=7.3
 
 UNAME_S := $(shell uname -s)
 ifeq ($(UNAME_S),Darwin)
@@ -19,8 +20,13 @@
 
 complete: roundcubemail-git
 	cp -RH roundcubemail-git roundcubemail-$(VERSION)
-	(cd roundcubemail-$(VERSION); jq '.require += {"kolab/net_ldap3": "~1.1.1"} | del(.suggest."kolab/net_ldap3")' --indent 4 composer.json-dist > composer.json)
-	(cd roundcubemail-$(VERSION); php /tmp/composer.phar install --prefer-dist --no-dev --ignore-platform-reqs --no-interaction)
+	(cd roundcubemail-$(VERSION); cp composer.json-dist composer.json)
+	(cd roundcubemail-$(VERSION); php /tmp/composer.phar config platform.php $(PHP_VERSION))
+	(cd roundcubemail-$(VERSION); php /tmp/composer.phar require "kolab/net_ldap3:~1.1.1" --no-update --no-install)
+	(cd roundcubemail-$(VERSION); php /tmp/composer.phar config --unset suggest.kolab/net_ldap3)
+	(cd roundcubemail-$(VERSION); php /tmp/composer.phar config --unset require-dev)
+	(cd roundcubemail-$(VERSION); php /tmp/composer.phar install --prefer-dist --no-dev --no-interaction)
+	(cd roundcubemail-$(VERSION); php /tmp/composer.phar config --unset platform)
 	(cd roundcubemail-$(VERSION); bin/install-jsdeps.sh --force)
 	(cd roundcubemail-$(VERSION); bin/jsshrink.sh program/js/publickey.js; bin/jsshrink.sh plugins/managesieve/codemirror/lib/codemirror.js)
 	(cd roundcubemail-$(VERSION); rm -f jsdeps.json bin/install-jsdeps.sh *.orig; rm -rf temp/js_cache)
@@ -73,7 +79,6 @@
 	npm install lessc
 	npm install less-plugin-clean-css
 	npm install csso-cli
-	@$(WHICH) jq || echo "!!!!!! Please install jq (https://stedolan.github.io/jq/) !!!!!!"
 
 /tmp/composer.phar:
 	curl -sS https://getcomposer.org/installer | php -- --install-dir=/tmp/

=== debian/changelog ===
roundcube (1.6.2+dfsg-1ubuntu0.2) mantic-security; urgency=medium

  * SECURITY UPDATE: Cross-site Scripting
    - debian/patches/CVE-2023-47272.patch: Fix cross-site scripting
      (XSS) vulnerability in setting Content-Type/Content-Disposition for
      attachment preview/download
    - debian/patches/CVE-2023-5631.patch: Fix cross-site scripting (XSS)
      vulnerability in handling of SVG in HTML messages (#9168)
    - debian/patches/CVE-2024-37383.patch: Fix cross-site scripting
      (XSS) vulnerability in handling SVG animate attributes
    - debian/patches/CVE-2024-37384.patch: Fix cross-site scripting
      (XSS) vulnerability in handling list columns from user preferences
      MIME-Version: 1.0 Content-Type: text/plain; charset=UTF-8 Content-
      Transfer-Encoding: 8bit
    - CVE-2023-47272
    - CVE-2023-5631
    - CVE-2024-37383
    - CVE-2024-37384

 -- Allen Huang <allen.huang@canonical.com>  Thu, 20 Jun 2024 11:48:48 +0100

roundcube (1.6.2+dfsg-1ubuntu0.1) mantic-security; urgency=medium

  * SECURITY UPDATE: cross-site scripting vulnerability
    - debian/patches/CVE-2023-43770.patch: Fix cross-site scripting (XSS)
      vulnerability in handling of linkrefs in plain text messages
    - CVE-2023-43770

 -- Nishit Majithia <nishit.majithia@canonical.com>  Fri, 23 Feb 2024 10:31:46 +0530

roundcube (1.6.2+dfsg-1) unstable; urgency=medium

  [ Amin Bandali ]
  * Test suite: Adjust short date test to make it work with all ICUs.
    (Closes: #1030161)

  [ Remus-Gabriel Chelu ]
  * Add Romanian debconf templates translation. (Closes: #1033468)

  [ Guilhem Moulin ]
  * New upstream bugfix release.
  * d/gbp.conf, d/README.source: Remove obsolete comment.
  * d/sql/mysql/1.3.0-1: Move inline comment.
  * d/p/fix-short-date-test-icu72.patch: Remove patch applied upstream.
  * Refresh patches.

 -- Guilhem Moulin <guilhem@debian.org>  Sun, 02 Jul 2023 11:54:33 +0200

=== debian/rules ===
--- 
+++ 
@@ -34,13 +34,13 @@
 
 # Minify JS: generate .min.js from .js source (cf. bin/jsshrink.sh)
 %.min.js: %.js
-	uglifyjs --compress --mangle $(if $(filter $@.map,$(GENERATED_MAPFILES)),--source-map "base='$(dir $@)'$(,)url='$(notdir $@).map'",) \
+	uglifyjs --compress --mangle $(if $(filter $@.map,$(GENERATED_MAPFILES)),--source-map "base='$(@D)'$(,)url='$(@F).map'",) \
 		-o $@ -- $<
 
 # Minify CSS: generate .min.css from .css source (cf. bin/cssshrink.sh)
 CSS_STAMPFILE = updatecss-stamp
 %.min.css: %.css $(CSS_STAMPFILE)
-	cd $(dir $@) && cleancss $(if $(filter $@.map,$(GENERATED_MAPFILES)),--source-map,) -o $(notdir $@) -- $(notdir $<)
+	cd $(@D) && cleancss $(if $(filter $@.map,$(GENERATED_MAPFILES)),--source-map,) -o $(@F) -- $(<F)
 
 # XXX bin/updatecss.sh edits CSS sources in place, so auto_clean might
 # not cleanup; it is idempotent so it doesn't matter too much for us though
@@ -92,9 +92,19 @@
 override_dh_auto_build: $(GENERATED_FILES) ;
 .SECONDARY:
 
+PHPUNIT_EXCLUDE_GROUPS = flaky
+ifeq ($(DEB_TARGET_ARCH_BITS),32)
+	# unfortunately BaconQrCode doesn't work for 32 bits archs, see
+	# https://github.com/Bacon/BaconQrCode/issues/76
+	PHPUNIT_EXCLUDE_GROUPS += qrcode
+endif
 override_dh_auto_test:
+	[ -d tests/.locale ] || mkdir tests/.locale
+	localedef -c -i en_US -f UTF-8 tests/.locale/en_US.utf8
 	ln -sfT ../.github/config-test.inc.php config/config-test.inc.php
-	env RCUBE_INSTALL_PATH=$(CURDIR) phpunit -c tests/phpunit.xml --exclude-group=qrcode
+	env RCUBE_INSTALL_PATH=$(CURDIR) LOCPATH=$(CURDIR)/tests/.locale \
+		phpunit -c tests/phpunit.xml --fail-on-skipped \
+			$(addprefix --exclude-group , $(PHPUNIT_EXCLUDE_GROUPS))
 
 NONCORE_PLUGINS = $(filter-out $(CORE_PLUGINS),$(PLUGINS))
 execute_after_dh_install:
@@ -157,10 +167,3 @@
 	mv -nt debian/$(if $(filter managesieve,$(CORE_PLUGINS)),roundcube-core,roundcube-plugins)/usr/share/doc/roundcube-plugins/plugins/managesieve \
 		debian/$(if $(filter managesieve,$(CORE_PLUGINS)),roundcube-core,roundcube-plugins)/usr/share/roundcube/plugins/managesieve/helpdocs
 
-override_dh_phpcomposer:
-	dh_phpcomposer --sourcedirectory=$(CURDIR)/debian/roundcube-core/usr/share/roundcube
-
-execute_after_dh_link:
-	# symlink plugin configuration (and delete existing usr/share/roundcube/plugins/*/config.inc.php
-	# file which we installed as etc/roundcube/plugins/*/config.inc.php instead)
-	$(foreach plugin,$(PLUGINS_CONFIGURABLE), \
